package com.sun.corba.se.impl.encoding;

import java.io.Serializable;
import org.omg.CORBA.Principal;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;
import org.omg.CORBA.Object;

public interface MarshalInputStream
{
    public abstract boolean read_boolean();
    
    public abstract char read_char();
    
    public abstract char read_wchar();
    
    public abstract byte read_octet();
    
    public abstract short read_short();
    
    public abstract short read_ushort();
    
    public abstract int read_long();
    
    public abstract int read_ulong();
    
    public abstract long read_longlong();
    
    public abstract long read_ulonglong();
    
    public abstract float read_float();
    
    public abstract double read_double();
    
    public abstract String read_string();
    
    public abstract String read_wstring();
    
    public abstract void read_boolean_array(boolean[] p0, int p1, int p2);
    
    public abstract void read_char_array(char[] p0, int p1, int p2);
    
    public abstract void read_wchar_array(char[] p0, int p1, int p2);
    
    public abstract void read_octet_array(byte[] p0, int p1, int p2);
    
    public abstract void read_short_array(short[] p0, int p1, int p2);
    
    public abstract void read_ushort_array(short[] p0, int p1, int p2);
    
    public abstract void read_long_array(int[] p0, int p1, int p2);
    
    public abstract void read_ulong_array(int[] p0, int p1, int p2);
    
    public abstract void read_longlong_array(long[] p0, int p1, int p2);
    
    public abstract void read_ulonglong_array(long[] p0, int p1, int p2);
    
    public abstract void read_float_array(float[] p0, int p1, int p2);
    
    public abstract void read_double_array(double[] p0, int p1, int p2);
    
    public abstract org.omg.CORBA.Object read_Object();
    
    public abstract TypeCode read_TypeCode();
    
    public abstract Any read_any();
    
    public abstract Principal read_Principal();
    
    public abstract org.omg.CORBA.Object read_Object(Class p0);
    
    public abstract Serializable read_value() throws Exception;
    
    public abstract void consumeEndian();
    
    public abstract int getPosition();
    
    public abstract void mark(int p0);
    
    public abstract void reset();
    
    public abstract void performORBVersionSpecificInit();
    
    public abstract void resetCodeSetConverters();
}
